Index: src/Parameters/Makefile.am
===================================================================
--- src/Parameters/Makefile.am	(revision 931077e6683b526f794c57753ad3fa7e42f94a10)
+++ src/Parameters/Makefile.am	(revision 24ac59f8087402366f826c725d203999e0bb3973)
@@ -76,4 +76,11 @@
 	Parameters/ValueInterface.hpp
 
+if CONDLEVMAR
+PARAMETERSOURCE += \
+	Parameters/Validators/Specific/PotentialTypeValidator.cpp
+PARAMETERHEADER += \
+	Parameters/Validators/Specific/PotentialTypeValidator.hpp
+endif
+
 noinst_LTLIBRARIES += libMolecuilderParameters.la
 libMolecuilderParameters_la_includedir = $(includedir)/MoleCuilder/
Index: src/Parameters/Validators/Specific/PotentialTypeValidator.cpp
===================================================================
--- src/Parameters/Validators/Specific/PotentialTypeValidator.cpp	(revision 24ac59f8087402366f826c725d203999e0bb3973)
+++ src/Parameters/Validators/Specific/PotentialTypeValidator.cpp	(revision 24ac59f8087402366f826c725d203999e0bb3973)
@@ -0,0 +1,58 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * PotentialTypeValidator.cpp
+ *
+ *  Created on: Apr 09, 2013
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "PotentialTypeValidator.hpp"
+
+#include "Potentials/PotentialFactory.hpp"
+#include "Potentials/Specifics/PotentialTypes.hpp"
+
+PotentialTypeValidator::PotentialTypeValidator() :
+DiscreteValidator<std::string>(std::vector<std::string>())
+{
+  // add all names from factory
+  const PotentialFactory &factory = PotentialFactory::getInstance();
+  for (PotentialTypes t = PotentialTypes_begin;
+      t != PotentialTypes_end; ++ t) {
+    PotentialFactory::TypeToName_t::const_iterator it = factory.TypeToName.find(t);
+    const std::string &name = it->second;
+    appendValidValue(name);
+  }
+}
+
+
+
+
Index: src/Parameters/Validators/Specific/PotentialTypeValidator.hpp
===================================================================
--- src/Parameters/Validators/Specific/PotentialTypeValidator.hpp	(revision 24ac59f8087402366f826c725d203999e0bb3973)
+++ src/Parameters/Validators/Specific/PotentialTypeValidator.hpp	(revision 24ac59f8087402366f826c725d203999e0bb3973)
@@ -0,0 +1,31 @@
+/*
+ * PotentialTypeValidator.hpp
+ *
+ *  Created on: Apr 09, 2013
+ *      Author: heber
+ */
+
+#ifndef POTENTIALTYPEVALIDATOR_HPP_
+#define POTENTIALTYPEVALIDATOR_HPP_
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <string>
+
+#include "Parameters/Validators/DiscreteValidator.hpp"
+
+/** This validator checks whether the given string refers to a valid
+ * \ref FormatParser type.
+ */
+class PotentialTypeValidator : public DiscreteValidator<std::string>
+{
+public:
+  PotentialTypeValidator();
+};
+
+
+#endif /* POTENTIALTYPEVALIDATOR_HPP_ */
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 931077e6683b526f794c57753ad3fa7e42f94a10)
+++ src/UIElements/Makefile.am	(revision 24ac59f8087402366f826c725d203999e0bb3973)
@@ -226,4 +226,8 @@
 	$(BOOST_THREAD_LDFLAGS)
 
+if CONDJOBMARKET
+libMolecuilderUI_la_LDFLAGS +=  $(LEVMAR_LDFLAGS)
+endif
+
 # NOTE: ActionPrototypes BEFORE Actions!
 # this is to ensure that static Action prototypes are instantiated after
@@ -249,4 +253,9 @@
 	libMolecuilderElement.la \
 	libMolecuilderRandomNumbers.la
+if CONDLEVMAR
+libMolecuilderUI_la_LIBADD += \
+	libMolecuilderPotentials.la \
+	libMolecuilderFunctionApproximation.la
+endif
 if CONDJOBMARKET
 libMolecuilderUI_la_LIBADD += \
@@ -264,4 +273,11 @@
 	$(BOOST_SYSTEM_LIBS) \
 	$(BOOST_THREAD_LIBS)
+
+if CONDLEVMAR
+libMolecuilderUI_la_LIBADD += \
+	$(LEVMAR_LIBS) \
+	$(LAPACK_LIBS) $(BLAS_LIBS) $(LIBS) $(FLIBS)
+endif
+
 
 nobase_libMolecuilderUI_la_include_HEADERS = ${UIHEADER}