Index: src/Actions/WorldAction/AddEmptyBoundaryAction.cpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision afbbfeb503903b1b9c5d9d837422eba4ef9792d7)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 26b4d62081a948abd7e73ffa88b6aec3eb1e5234)
@@ -117,5 +117,5 @@
     return ActionState::ptr(UndoState);
   } else {
-    ELOG(2, "There must be atoms present for AddingEmptyBoundary.");
+    STATUS("There must be atoms present for AddingEmptyBoundary.");
     return Action::failure;
   }
Index: src/Actions/WorldAction/CenterOnEdgeAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.cpp	(revision afbbfeb503903b1b9c5d9d837422eba4ef9792d7)
+++ src/Actions/WorldAction/CenterOnEdgeAction.cpp	(revision 26b4d62081a948abd7e73ffa88b6aec3eb1e5234)
@@ -80,5 +80,5 @@
   // get maximum and minimum
   if (AllAtoms.empty()) {
-    ELOG(2, "For WorldCenterOnEdgeAction atoms must be present.");
+    STATUS("There are no atoms present.");
     return Action::failure;
   }
Index: src/Actions/WorldAction/InputAction.cpp
===================================================================
--- src/Actions/WorldAction/InputAction.cpp	(revision afbbfeb503903b1b9c5d9d837422eba4ef9792d7)
+++ src/Actions/WorldAction/InputAction.cpp	(revision 26b4d62081a948abd7e73ffa88b6aec3eb1e5234)
@@ -72,5 +72,5 @@
     parsers.SetOutputPrefixForAll(FilenamePrefix);
   } else {
-    ELOG(1, "Input file does not have a suffix, cannot recognize format.");
+    STATUS("Input file does not have a suffix, cannot recognize format.");
     return Action::failure;
   }
@@ -103,4 +103,5 @@
 //  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
 
+  STATUS("Undo of WorldInputAction not implemented.");
   return Action::failure;
 //  string newName = state->mol->getName();
@@ -111,4 +112,5 @@
 
 ActionState::ptr WorldInputAction::performRedo(ActionState::ptr _state){
+  STATUS("Redo of WorldInputAction not implemented.");
   return Action::failure;
 }
Index: src/Actions/WorldAction/OutputAction.cpp
===================================================================
--- src/Actions/WorldAction/OutputAction.cpp	(revision afbbfeb503903b1b9c5d9d837422eba4ef9792d7)
+++ src/Actions/WorldAction/OutputAction.cpp	(revision 26b4d62081a948abd7e73ffa88b6aec3eb1e5234)
@@ -60,5 +60,5 @@
   // Parser configured to save anything?
   if (!FormatParserStorage::getInstance().isAbleToSave()){
-    ELOG(1, "No parser or file prefix selected.");
+    STATUS("No parser or file prefix selected.");
     return Action::failure;
   }
@@ -73,4 +73,5 @@
 //  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
 
+  STATUS("Undo of WorldOutputAction not implemented.");
   return Action::failure;
 //  string newName = state->mol->getName();
@@ -81,4 +82,5 @@
 
 ActionState::ptr WorldOutputAction::performRedo(ActionState::ptr _state){
+  STATUS("Redo of WorldOutputAction not implemented.");
   return Action::failure;
 }
Index: src/Actions/WorldAction/OutputAsAction.cpp
===================================================================
--- src/Actions/WorldAction/OutputAsAction.cpp	(revision afbbfeb503903b1b9c5d9d837422eba4ef9792d7)
+++ src/Actions/WorldAction/OutputAsAction.cpp	(revision 26b4d62081a948abd7e73ffa88b6aec3eb1e5234)
@@ -64,5 +64,5 @@
     FilenamePrefix = params.filename.get().stem().string();
   } else {
-    ELOG(1, "Output file does not have a suffix, cannot recognize format.");
+    STATUS("Output file does not have a suffix, cannot recognize format.");
     return Action::failure;
   }
@@ -75,5 +75,6 @@
     FormatParserStorage::getInstance().saveWorld(output, FilenameSuffix);
   } else {
-    ELOG(1, "Could not open file " << params.filename.get() << ".");
+    STATUS("Could not open file "+params.filename.get().string()+".");
+    return Action::failure;
   }
   output.close();
@@ -85,4 +86,5 @@
 //  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
 
+  STATUS("Undo of WorldOutputAsAction not implemented.");
   return Action::failure;
 //  string newName = state->mol->getName();
@@ -93,4 +95,5 @@
 
 ActionState::ptr WorldOutputAsAction::performRedo(ActionState::ptr _state){
+  STATUS("Redo of WorldOutputAsAction not implemented.");
   return Action::failure;
 }